#!/usr/bin/python
import sys
import re
import math
import utils

print "\n\n * * * Make xyz file from the Abinit input file * * *"
if len(sys.argv)==1 :
	print " Error! usage makexyz.py abinit_inputfile"
	sys.exit()
try:
	abinit=open(sys.argv[1],'r')
except IOError, error:
	print " problem while reading '%s': '%s" % (sys.argv[1], error)
print " File name: ",sys.argv[1]

output=open("structure.xyz","w")
i=0
lines=abinit.readlines()
acell = {}
utils.string_to_double("acell", 3, acell, lines)
print " Acell ",acell[0],acell[1],acell[2]

natom =utils.string_to_1int("natom", lines)
print " natom ",natom


ntypat = utils.string_to_1int("ntypat", lines)
print " ntypat ",ntypat

typat = {}
utils.string_to_int("typat", natom, typat, lines)

znucl = {}
utils.string_to_int("znucl", ntypat,znucl, lines)
print ' Atom types :'
for i in range(0,ntypat):
	print ' Atom ',i,' : ',utils.number_to_atom(znucl[i])

rprim = {}
utils.string_to_double("rprim", 9,rprim, lines)
print " rprim : ",rprim[0],rprim[1],rprim[2], " | ",rprim[3],rprim[4],rprim[5]," | ",rprim[6],rprim[7],rprim[8]

xredon=False
xcart={}
if utils.line_number("xred",lines)!=-1:
	print ' Use reduce coordinates '
	xredon=True

if xredon:
	xred={}
	utils.string_to_double("xred",3*natom,xred,lines)
	print " Sorry this script read only xcart "
	sys.exit()
#!	xred_to_xcart(xred,xcart,rprim,acell,natom[0])

utils.string_to_double("xcart", 3*natom, xcart, lines)
print " Multiply for: "
nx=input(' nx : ')
ny=input(' ny : ')
nz=input(' nz : ')

ntotatom=natom*nx*ny*nz

if(ntotatom<0):
	print " Error! choose nx,ny,nz > 0 "
	sys.exit(0)
	
print 'Total number of atoms :',ntotatom
output.write(repr(ntotatom)+"\n")
output.write("# generate by makexyz.py \n")

rprim[0]=rprim[0]*acell[0]
rprim[1]=rprim[1]*acell[0]
rprim[2]=rprim[2]*acell[0]

rprim[3]=rprim[3]*acell[1]
rprim[4]=rprim[4]*acell[1]
rprim[5]=rprim[5]*acell[1]

rprim[6]=rprim[6]*acell[2]
rprim[7]=rprim[7]*acell[2]
rprim[8]=rprim[8]*acell[2]

for d1 in range(0,nx):
	for d2 in range(0,ny):
		for d3 in range(0,nz):
			x=rprim[0]*d1+rprim[3]*d2+rprim[6]*d3
			y=rprim[1]*d1+rprim[4]*d2+rprim[7]*d3
			z=rprim[2]*d1+rprim[5]*d2+rprim[8]*d3
			for i in range(0,natom):
				line = "%s  %5.5f  %5.5f  %5.5f " % (utils.number_to_atom(znucl[typat[i]-1]),xcart[i*3]+x,xcart[i*3+1]+y,xcart[i*3+2]+z)
				output.write(line+"\n")
abinit.close()
output.close()
